﻿Public Class Form1
  Private PrintString As String

  Private Sub Form1_Load(ByVal sender As System.Object,
    ByVal e As System.EventArgs) Handles MyBase.Load

    Me.Text = "印刷テスト"
    TextBox1.Multiline = True
    TextBox1.ScrollBars = ScrollBars.Vertical
    TextBox1.Dock = DockStyle.Fill

    Const unit As Double = 0.254
    Dim margin As Integer = 20 / unit
    PrintDocument1.DefaultPageSettings.Margins =
      New System.Drawing.Printing.Margins(
      margin, margin, margin, margin)

    PrintDialog1.AllowPrintToFile = False
    PrintDialog1.Document = PrintDocument1
    PrintPreviewDialog1.Document = PrintDocument1
    PageSetupDialog1.EnableMetric = True
    PageSetupDialog1.Document = PrintDocument1
  End Sub

  Private Sub ButtonPrint_Click(ByVal sender As System.Object,
    ByVal e As System.EventArgs) Handles ButtonPrint.Click

    If DialogResult.OK = PrintDialog1.ShowDialog() Then
      SetPrintDocument()
      PrintDocument1.Print()
    End If
  End Sub

  Sub SetPrintDocument()
    PrintString = TextBox1.Text
    PrintDocument1.DocumentName = "テスト"
  End Sub

  Private Sub PrintDocument1_PrintPage(
    ByVal sender As System.Object,
    ByVal e As System.Drawing.Printing.PrintPageEventArgs
    ) Handles PrintDocument1.PrintPage

    Dim font As New Font("MS ゴシック", 12)
    Dim charactersOnPage As Integer = 0
    Dim linesPerPage As Integer = 0

    e.Graphics.MeasureString(PrintString, font,
      e.MarginBounds.Size, StringFormat.GenericTypographic,
      charactersOnPage, linesPerPage)
    e.Graphics.DrawString(PrintString, font,
      Brushes.Black, e.MarginBounds,
      StringFormat.GenericTypographic)
    PrintString = PrintString.Substring(charactersOnPage)
    If PrintString.Length > 0 Then
      e.HasMorePages = True
    Else
      e.HasMorePages = False
      PrintString = TextBox1.Text
    End If
  End Sub

  Private Sub ButtonPreview_Click(ByVal sender As System.Object,
    ByVal e As System.EventArgs) Handles ButtonPreview.Click

    SetPrintDocument()
    PrintPreviewDialog1.ShowDialog()
  End Sub

  Private Sub ButtonPageSetting_Click(
    ByVal sender As System.Object, ByVal e As System.EventArgs
    ) Handles ButtonPageSetting.Click

    PageSetupDialog1.ShowDialog()
  End Sub
End Class
